<?php

/* vim: set filetype=php : */

/**
 * @file
 * Current visitor block.
 */

/**
 * Implementation of hook_block().
 */
function visitors_block($op = 'list', $delta = 0, $edit = array()) {
  if ($op == 'list') {
    $blocks[0]['info'] = t('Current visitor');
    return $blocks;
  }

  if ($op == 'view') {
    $block['subject'] = t('Visitors');
    $block['content'] = theme('visitors_block_view');
    return $block;
  }
}

/**
 * Implement a theme function for block output.
 */
function theme_visitors_block_view() {
  $list_items = array();

  if (variable_get('visitors_show_total_visitors', 1)) {
    $list_items[] = t('Total Visitors: %visitors', array('%visitors' => db_result(db_query("SELECT COUNT(*) FROM {visitors}"))));
  }
  if (variable_get('visitors_show_unique_visitor', 1)) {
    $list_items[] = t('Unique Visitors: %unique_visitors', array('%unique_visitors' => db_result(db_query("SELECT COUNT(DISTINCT visitors_ip) FROM {visitors}"))));
  }
  if (variable_get('visitors_registered_user', 1)) {
    $list_items[] = t('Registered Users: %registered_user', array('%registered_user' => db_result(db_query("SELECT COUNT(*) FROM {users} WHERE uid <> 0"))));
  }
  if (variable_get('visitors_last_registered_user', 1)) {
    $last_user = db_fetch_object(db_query_range("SELECT * FROM {users} ORDER BY uid DESC", 0, 1));
    $list_items[] = t('Last Registered User: !last_user', array('!last_user' => theme('username', $last_user)));
  }
  if (variable_get('visitors_published_nodes', 1)) {
    $list_items[] = t('Published Nodes: %nodes', array('%nodes' => db_result(db_query("SELECT COUNT(*) FROM {node} WHERE status = 1"))));
  }
  if (variable_get('visitors_user_ip', 1)) {
    $list_items[] = t('Your IP: %user_ip', array('%user_ip' => visitors_get_ip()));
  }
  if (variable_get('visitors_since_date', 1)) {
    $since_date = db_result(db_query_range("SELECT visitors_date_time FROM {visitors} ORDER BY visitors_date_time ASC", 0, 1));
    $list_items[] = t('Since: %since_date', array('%since_date' => format_date($since_date, 'short')));
  }

  return theme('item_list', $list_items);
}

